%{
/* $Header: /afs/ece/usr/lowpower/CMUDSP/cvsroot/cmudsp/misc/c-code/qdvpp/verilog.l,v 1.1 1998/11/03 18:09:18 inacio Exp $ */
/*****************************************************************************
 *verilog.l
 *
 * quick and dirty Verilog preprocessor lexer description
 *
 *
 *****************************************************************************/

/*
 * a define to know we're in the lexer
 */
#define VERILOG_SCANNER

/*
 * Includes
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "qdhash.h"


/*
 * local prototypes
 */
static char * strip_spaces (char *instr);



/*
 * variables used by the scanner actions
 */
Tdefined_val *current_val = NULL;
char *temp_string = NULL;
char *temp2_string = NULL;
int discard_input = 0;
int want_defined = 1;
int does_exist = 0;
int old_state;

%}

%option perf-report verbose full outfile="verilog.c"


%x GET_DEF_STATE GET_DEF_VALUE GET_IDEF_VALUE 
%x COND_EE_STATE EE_STATE COMMENT

SPACE [[:blank:]]


%%

<INITIAL>^{SPACE}*"\`define"		{BEGIN GET_DEF_STATE;
                                    fprintf (stdout, "%s", yytext);
                                 }
<INITIAL>^{SPACE}*"\`ifdef"		   {BEGIN GET_IDEF_VALUE;
                                    does_exist = 0;
                                    want_defined = 1;
                                 }
<INITIAL>^{SPACE}*"\`ifndef"		{BEGIN GET_IDEF_VALUE;
                                    does_exist = 0;
                                    want_defined = 0;
                                 }
<GET_DEF_STATE>.*=		         {BEGIN GET_DEF_VALUE;
         					            if (current_val != NULL)
         					            {
         					               fprintf (stderr, "You have a `define in a `define or the scanner is completely confused!\n");
         					               fprintf (stderr, "\tthe scanner can't continue, current input token is:\n");
         					               fprintf (stderr, "\t\"%s\"\n",yytext);
         					               exit (255);
         					            }
         					            current_val = (Tdefined_val *) malloc (sizeof(Tdefined_val));
         					            current_val->name = NULL;
         					            current_val->num_value = 0;
         					            current_val->str_value = NULL;
         					            temp_string = (char *) malloc ( (strlen(yytext)+1) * sizeof(char) );
         					            *(temp_string+strlen(temp_string)) = NULL;
         					            temp2_string = strip_spaces (temp_string);
         					            free (temp_string);
         					            temp_string = NULL;
         					            current_val->name = temp2_string;
         					            temp2_string = NULL;
         					            
         					            fprintf (stdout, "%s", yytext);
         				            }
<GET_DEF_STATE>.*  		         {BEGIN INITIAL;
                                    if (current_val != NULL)
                                    {
         					               fprintf (stderr, "You have a `define in a `define or the scanner is completely confused!\n");
         					               fprintf (stderr, "\tthe scanner can't continue, current input token is:\n");
         					               fprintf (stderr, "\t\"%s\"\n",yytext);
         					               exit (255);
                                    }
         					            current_val = (Tdefined_val *) malloc (sizeof(Tdefined_val));
         					            current_val->name = NULL;
         					            current_val->num_value = 0;
         					            current_val->str_value = NULL;
         					            temp_string = strip_spaces (yytext);
         					            current_val->name = temp_string;
         					            temp_string = NULL;
         					            hash_add (current_val);
         					            current_val = NULL;
         					            
         					            fprintf (stdout, "%s", yytext);
                                 }
<GET_DEF_VALUE>.*                {BEGIN INITIAL;
                                    if (current_val == NULL)
                                    {
                                       fprintf (stderr, "I don't know what happened, I'm losy in scanner states!\n");
                                       fprintf (stderr, "\tbut I cannot continue\n");
                                       exit(255);
                                    }
                                    temp_string = strip_spaces (yytext);
                                    current_val->str_value = temp_string;
                                    temp_string = NULL;
                                    hash_add(current_val);
                                    current_val = NULL;
                                    
                                    fprintf (stdout, "%s", yytext);
                                 }
<GET_IDEF_VALUE>.*               {BEGIN COND_EE_STATE;
                                    temp_string = strip_spaces(yytext);
                                    does_exist = hash_lookup (temp_string);
                                    if (does_exist && want_defined)
                                    {
                                       discard_input = 0;
                                    }
                                    else
                                    {
                                       discard_input = 1;
                                    }
                                    free (temp_string);
                                    temp_string = NULL;
                                 }
<COND_EE_STATE>^{SPACE}*"`else"{SPACE}*          {BEGIN EE_STATE;
                                       discard_input = !discard_input;
                                    }
<COND_EE_STATE>.*                {
                                    if (!discard_input)
                                       fprintf (stdout, "%s", yytext); 
                                 }
<EE_STATE>^{SPACE}*"`endif"{SPACE}*      {BEGIN INITIAL;
                                    discard_input = 0;
                                 }
<EE_STATE>.*                   {
                                    if (!discard_input)
                                    {
                                       fprintf (yyout, "%s", yytext);
                                    }
                                 }
<COMMENT>\*\/                     { BEGIN old_state;
                                    if (!discard_input)
                                    {
                                       fprintf (yyout, "%s", yytext);
                                    }
                                 }
<COMMENT>.*                      { if (!discard_input)
                                   {
                                       fprintf (yyout, "%s", yytext);
                                   }
                                 }

.                      { 
                           if (!discard_input)
                              fprintf (stdout, "%s", yytext); 
                        }
\n                      { fprintf (stdout, "\n"); }

%%


/*****************************************************************************
 *yywrap
 *
 *
 *****************************************************************************/
int
yywrap ()
{
	return 1;
}


/*****************************************************************************
 *strip_spaces
 *
 *strips the space off the front and back of a string
 *****************************************************************************/
static
char *
strip_spaces (char *instr)
{
	char *beg_new_str = NULL;
	char *end_new_str = NULL;
	char *answer_string = NULL;
	int new_str_size = 0;
/*
 *debug this!
 */
	char *blah_1, *blah_2;
 	int input_string_size = strlen (instr);
 	blah_1 = instr + input_string_size;
 	blah_2 = instr + input_string_size - 1;
 	

	
	beg_new_str = instr;
	while (isspace(*beg_new_str))
	{
		beg_new_str++;
	}

	
	end_new_str = instr + strlen(instr) - 1;
	while (isspace(*end_new_str))
	{
		end_new_str--;
	}
	
	new_str_size = (end_new_str + 1) - beg_new_str;;
	
	if (new_str_size < 1)
		return NULL;
		
	answer_string = (char *) malloc (sizeof (char) * (new_str_size+1) );
	
   /* bzero (answer_string, new_str_size+1); */
	strncpy (answer_string, beg_new_str, new_str_size);
	*(answer_string+new_str_size) = NULL;
	
	return answer_string;

}



/*****************************************************************************
 *****************************************************************************/
