// File: mydecoder.v 
// Module name:  mydecoder
// A 2-4 decoder
// Used in AGU register files to generate write enable signals.
// Author: Jonathan Tong.

module mydecoder(
	SEL,
        Y
	);

input [1:0] SEL;
output [3:0] Y;

reg [3:0]Y;

always @(SEL)
	case (SEL)
		2'b00 : Y = 4'b0001;
		2'b01 : Y = 4'b0010;
		2'b10 : Y = 4'b0100;
		2'b11 : Y = 4'b1000;
	endcase

endmodule
