/*
 Written by Andrew Ryan
 Fast version of bounds checker
 That's about it...
 6/11/98
 */



module bound_chk (linear, lower, upper, within_boundaries);
   input  [15:0] linear;
   input [15:0]  lower;
   input [15:0]  upper;
   output 	 within_boundaries;

   parameter 	 DPATH = "bound_chk";
   
   wire [15:0] 	 linear_not, upper_not;
   wire [16:0] 	 add_lower_out, add_upper_out;

`ifdef DW
   assign upper_not = ~upper;
`else   
   inv #(16, 1, DPATH) inv_upper (upper, upper_not);
`endif 

`ifdef DW
   assign linear_not = ~linear;
`else   
   inv #(16, 1, DPATH) inv_linear (linear, linear_not);
`endif 
   
`ifdef DW
   DW01_add #(17) add_upper (.A({1'b0, linear}), .B({1'b1, upper_not}), 
			       .CI(1'b0), .SUM(add_upper_out), .CO());
`else
   addhs #(17, 1, DPATH) add_upper ({1'b0, linear},
				    {1'b1, upper_not},
				    1'b0, , add_upper_out);
`endif 

`ifdef DW
    DW01_add #(17) adder_lower (.A({1'b0, lower}), .B({1'b1, linear_not}), 
				.CI(1'b0), .SUM(add_lower_out), .CO()); 
`else  
   addhs #(17, 1, DPATH) add_lower ({1'b0, lower},
				    {1'b1, linear_not},
				    1'b0, , add_lower_out);
`endif   

`ifdef DW
   assign within_boundaries = add_upper_out[16] & add_lower_out[16];
`else   
   stdand2 bound_chk_and (add_upper_out[16], add_lower_out[16], within_boundaries);
`endif
				
endmodule // bound_chk_new



