/* $Id: cmudsp.v,v 1.28 1998/08/26 19:48:55 inacio Exp $ */
/*****************************************************************************
 *cmudsp.v
 *
 *This is the top of the whole chip....
 *
 *
 *Copyright (C) 1997 Carnegie Mellon University
 *
 *Author: $Author: inacio $
 *Date: $Date: 1998/08/26 19:48:55 $
 *Revision: $Revision: 1.28 $
 *
 *
 *Log: $Log: cmudsp.v,v $
 *Log: Revision 1.28  1998/08/26 19:48:55  inacio
 *Log: changed the module names to cmudsp
 *Log:
# Revision 1.27  1998/06/16  15:18:38  ar39
# Made PAB a true bi-directional bus.
#
 *Log: Revision 1.26  1998/06/15 17:02:21  ar39
 *Log: Split more AGU clocks--whoo-hoo!
 *Log:
 *Log: Revision 1.25  1998/06/10 21:32:53  ar39
 *Log: Split the PCU clock.
 *Log:
 *Log: Revision 1.24  1998/06/02 20:58:01  ar39
 *Log: Split clock nets.
 *Log:
 *Log: Revision 1.23  1998/03/31 17:54:04  ar39
 *Log: *** empty log message ***
 *Log:
 *Log: Revision 1.22  1998/03/31 17:48:08  ar39
 *Log: *** empty log message ***
 *Log:
 *Log: Revision 1.21  1998/03/30 19:17:19  ar39
 *Log: *** empty log message ***
 *Log:
 *Log: Revision 1.20  1998/02/25 22:04:24  ar39
 *Log: Moved the clock attribute stuff to clock_stop.v
 *Log:
 *Log: Revision 1.19  1998/02/18 23:35:08  ar39
 *Log: Split the clock into the AGU.
 *Log:
 *Log: Revision 1.18  1998/02/14 16:29:19  ar39
 *Log: Added a third clock net.
 *Log:
 *Log: Revision 1.17  1998/01/30 23:52:21  ar39
 *Log: Took off the ESTROBE from the clock group.
 *Log:
 *Log: Revision 1.16  1998/01/29 22:49:49  ar39
 *Log: Added net attributes to core_clock, ESTROBE
 *Log:
 *Log: Revision 1.15  1998/01/19 17:54:33  inacio
 *Log: got rid of another epoch syntax error line
 *Log:
# Revision 1.14  1998/01/19  17:53:38  inacio
# those all had syntax errors in them!
#
# Revision 1.13  1998/01/19  17:46:43  inacio
# one of these has to work for the clock!
#
# Revision 1.12  1997/12/17  20:02:52  yftong
# *** empty log message ***
#
# Revision 1.11  1997/12/14  23:19:05  benk
# Reworked interface to ram_system
#
# Revision 1.10  1997/12/09  21:33:54  inacio
# fixed the mem busses
#
# Revision 1.9  1997/11/18  23:36:29  inacio
# added parameters to the ramswitch
#
# Revision 1.8  1997/11/07  22:39:12  inacio
# added moving the control signals up from the ram_switch to the pads, forget
# to add the parameters to the ram_switch modules
#
# Revision 1.7  1997/10/31  08:12:05  inacio
# changed one of the SCAN_OUT2's to be a SCAN_OUT1 to be correct
#
# Revision 1.6  1997/10/29  22:47:18  inacio
# Lots of changes for pad support and testing support of the scan chain
#
# Revision 1.5  1997/10/24  19:21:24  inacio
# changed the RAM size
#
# Revision 1.4  1997/10/21  22:04:30  inacio
# added comments to have epoch treat some signals as clocks
#
# Revision 1.3  1997/10/21  21:02:22  inacio
# added LOTS of wires, fixed the parameters to ram_switch to include
# E_PDB_OUT, and added lots more wires!
#
# Revision 1.2  1997/10/17  18:43:21  inacio
# added name to ram module instance
#
# Revision 1.1  1997/10/16  20:15:57  inacio
# The first whack at making the entire core!
#
 *****************************************************************************/

`define databus 23:0
`define addrbus 15:0
`define dmemsize 1024
`define daddrbits 10
`define pmemsize (2*`dmemsize)
`define paddrbits (`daddrbits+1)


/*
 * build clock trees with epoch
 *
 */
 
module cmudsp (CLOCK, RESET_unlat, MEM_SLCT, ESTROBE, EACCESS, EENABLE, EAB, EDB,
					E_OUTEN, E_WRITE, TEST, SCAN_IN1, SCAN_OUT1, 
					edb_dir, edb_en, eab_dir, eab_en);
					
input 		CLOCK;
input		RESET_unlat;
input		[1:0]MEM_SLCT;
output		ESTROBE;
output		EACCESS;
input		EENABLE;
inout		[`databus]EDB;
inout		[`addrbus]EAB;
inout		E_OUTEN;
inout		E_WRITE;
input		TEST;
input		SCAN_IN1;
output		SCAN_OUT1;
output		edb_dir;
output		edb_en;
output		eab_dir;
output		eab_en;


/*
 *
 * The huge list of wires begins....
 *
 */
wire		[`addrbus]E_PAB;
wire		[`addrbus]E_XAB;
wire		[`addrbus]E_YAB;
wire		[`addrbus]C_PAB;
wire		[`addrbus]C_XAB;
wire		[`addrbus]C_YAB;

wire		[`databus]C_PDB;
wire		[`databus]C_XDB;
wire		[`databus]C_YDB;


wire		[`databus]E_PDB_IN;
wire		[`databus]E_PDB_OUT;
wire		[`databus]E_XDB_IN;
wire		[`databus]E_XDB_OUT;
wire		[`databus]E_YDB_IN;
wire		[`databus]E_YDB_OUT;

wire		C_XREAD, C_YREAD;
wire		C_XWRITE, C_YWRITE;
wire		E_POUTEN, E_XOUTEN, E_YOUTEN;
wire		E_PWRITE, E_XWRITE, E_YWRITE;
wire		ESTROBE;
wire            Clk_agu_0_rfm;
wire            Clk_agu_1_rfn;
wire            Clk_agu_2_rfr;
wire            Clk_agu_3_ctrl;
wire            Clk_agu_4_ctrl;
wire            Clk_agu_5_misc;
wire            Clk_agu_6_misc;
wire            Clk_alu_0_xy;
wire            Clk_alu_1_ab;
wire            Clk_alu_2_misc;
wire            Clk_bus_0;
wire            Clk_pcu_0;
wire            Clk_pcu_1;

   
dff #(1, 0)	dff_reset(CLOCK, RESET_unlat, RESET);

ram_switch #(6, 6, 16, 24, 1024, 10, 1024, 10) bus_control (RESET, MEM_SLCT,
                  ESTROBE, EACCESS, EENABLE, CLOCK,
		  Clk_agu_0_rfm, Clk_agu_1_rfn, Clk_agu_2_rfr,
		  Clk_agu_3_ctrl, Clk_agu_4_ctrl, Clk_agu_5_misc, Clk_agu_6_misc,
		  Clk_alu_0_xy, Clk_alu_1_ab, Clk_alu_2_misc,
                  Clk_bus_0, Clk_pcu_0, Clk_pcu_1, TEST, C_PAB,
                  C_PDB, C_XAB, C_XDB, C_XREAD, C_XWRITE, C_YAB, C_YDB,
                  C_YREAD, C_YWRITE, E_PAB, E_PDB_IN, E_PDB_OUT, E_POUTEN,
                  E_PWRITE, E_XAB, E_XDB_IN, E_XDB_OUT, E_XOUTEN, E_XWRITE,
                  E_YAB, E_YDB_IN, E_YDB_OUT, E_YOUTEN, E_YWRITE, EAB, EDB,
                  E_OUTEN, E_WRITE, edb_dir, edb_en, eab_dir, eab_en);

core_cascade dsp (RESET, C_PDB, C_XDB, C_YDB, C_PAB, C_XAB, C_XWRITE, 
                  C_XREAD, C_YAB, C_YWRITE, C_YREAD,
		  Clk_agu_0_rfm, Clk_agu_1_rfn, Clk_agu_2_rfr,
		  Clk_agu_3_ctrl, Clk_agu_4_ctrl, Clk_agu_5_misc, Clk_agu_6_misc,
		  Clk_alu_0_xy, Clk_alu_1_ab, Clk_alu_2_misc,
                  Clk_bus_0, Clk_pcu_0, Clk_pcu_1, 
                  TEST, SCAN_IN1, SCAN_OUT1);


ram_system #(1024, 10, 1024, 10) memory	
   (.xaddress(E_XAB[9:0]), .xdbus_in(E_XDB_OUT), .xoe(E_XOUTEN),
    .xwr(E_XWRITE), .xdbus_out(E_XDB_IN), 
    .yaddress(E_YAB[9:0]), .ydbus_out(E_YDB_IN), .yoe(E_YOUTEN),
    .ywr(E_YWRITE), .ydbus_in(E_YDB_OUT), 
    .paddress(E_PAB[9:0]), .pdbus_out(E_PDB_IN), .poe(E_POUTEN),
    .pwr(E_PWRITE), .pdbus_in(E_PDB_OUT)
    );

endmodule

