// Master file for RTL-level simulation
// 
// NOTE: 
// (1) If any module (including those in the vendor libraries) use the
// `timescale directive (eg `timescale 1ns / 10ps), that diretive
// (i.e. `timescale 1ns / 10 ps in this case) has to be added to the beginning
// of the 1st file in this master file or else Verilog-XL is going to 
// complain about it. Now a separate file timescale.v is used for this purpose.


// comment out the following line if Cascade components are to be used
+define+DW
+define+SIM

../cmudsp/structural/timescale.v

/* Cascade and DesignWare libraries */
+libext+.v+
-y /afs/ece/usr/ar39/stdcell/synopsys/verilog
-v /afs/ece/usr/ar39/stdcell/synopsys/verilog_primitives.v
-y /afs/ece/common/local/usr/supported/synopsys/dw/dw01/src_ver
-y /afs/ece/common/local/usr/supported/synopsys/dw/dw02/src_ver
-y /afs/ece/common/local/usr/supported/synopsys/dw/dw03/src_ver
-y /afs/ece/common/local/usr/supported/synopsys/dw/dw04/src_ver
-y /afs/ece/common/local/usr/supported/synopsys/dw/dw05/src_ver
-y /afs/ece/common/local/usr/supported/synopsys/dw/dw06/src_ver
-y /afs/ece/common/local/usr/supported/synopsys/dw/dw07/src_ver

/* defines */
../cmudsp/structural/globals.v
../cmudsp/structural/ctl_def.v





/* agu files that got to synopsys */

  /*
../cmudsp/structural/agu/before_syn/agu_control.v             
../cmudsp/structural/agu/before_syn/multi_wrap_address.v
../cmudsp/structural/agu/before_syn/address_mode.v      
../cmudsp/structural/agu/before_syn/write_enable_selector.v
../cmudsp/structural/agu/before_syn/agu_tristate.v          
../cmudsp/structural/agu/before_syn/lower_upper.v            
../cmudsp/structural/agu/before_syn/mydecoder.v
../cmudsp/structural/agu/before_syn/regset_selector_c.v

../cmudsp/structural/agu/addr_alu.v
../cmudsp/structural/agu/agu_structural.v
../cmudsp/structural/agu/linear_bitreverse.v
../cmudsp/structural/agu/rfm.v
../cmudsp/structural/agu/rfn.v
../cmudsp/structural/agu/rfr.v
../cmudsp/structural/agu/wrap_once_address.v
../cmudsp/structural/agu/agu_control_wrapper.v
../cmudsp/structural/agu/bound_chk.v
../cmudsp/structural/alu/before_syn/check_imm.v
  */

../synopsys/syn/agu_structural.v






/* pcu files */

  /*
../cmudsp/structural/pcu/pcu_structural.v
../cmudsp/structural/pcu/before_syn/pcu_stage2.v
../cmudsp/structural/pcu/before_syn/pcu_stage3.v
../cmudsp/structural/pcu/before_syn/pcu_control.v
  */

../synopsys/syn/pcu_structural.v






/* data switch files    WORKS WORKS WORKS  */

  /*
../cmudsp/structural/bus_switch/bus_switch.v
../cmudsp/structural/bus_switch/before_syn/bs_control.v
  */

../synopsys/syn/bus_switch.v






/* alu */
/* files that go through synopsys */

  /*
../cmudsp/structural/alu/before_syn/mult_decoder.v
../cmudsp/structural/alu/before_syn/control.v
../cmudsp/structural/alu/before_syn/control_p.v
../cmudsp/structural/alu/before_syn/extcheck_c.v

../cmudsp/structural/alu/XYregImm_c.v 
../cmudsp/structural/alu/XYregImm_scan.v
../cmudsp/structural/alu/round_c.v
../cmudsp/structural/alu/shift1_c.v
../cmudsp/structural/alu/logic_c.v
../cmudsp/structural/alu/mux_mult.v
../cmudsp/structural/alu/mux_add.v
../cmudsp/structural/alu/mux_logic.v
../cmudsp/structural/alu/limit_c.v
../cmudsp/structural/alu/alu_struc.v
  */

../synopsys/syn/alu_struc.v






/* Top level */

  ../cmudsp/structural/core_cascade.v
  // ../synopsys/syn/core_cascade.v

/* test bench related models */
async_ramb.v
core_ram_struc.v

/* the test bench */
test.v 

