/*	File:	core+.v	  					*/

/*	module name: core+						*/

/*	Description: core1 + ram					*/


/*==============================================================================*/

/********************************************************************************/
/*																				*/
/*	module:	core+																*/
/*																				*/
/********************************************************************************/

module core_ram_s (
	reset,
	Clk
	);


/*============	I/O direction	================================================*/

input reset;

input Clk;

/*==============================================================================*/



/*============		I/O type	================================================*/
wire reset;
wire Clk;

/*==============================================================================*/



/*===========	Internal Nets	================================================*/

wire [`databus] PDB;

wor [`addrbus] PAB;

wire [`databus] XDB;
wire [`addrbus] XAB;
wire XWRITE, XREAD;

wire [`databus] YDB;
wire [`addrbus] YAB;
wire YWRITE, YREAD;



/*==============================================================================*/



/*===========	Module Instantiations	 =======================================*/

core_s CORE(
	.reset(reset),
	.PDB(PDB),
	.XDB(XDB),
	.YDB(YDB),
	.PAB(PAB),
	.XAB(XAB),
	.XWRITE(XWRITE),
	.XREAD(XREAD),
	.YAB(YAB),
	.YWRITE(YWRITE),
	.YREAD(YREAD),
	.Clk(Clk)
	);
	
/*--------------------------*/
/*			RAM  			*/
/*--------------------------*/

async_ramb XRAM(
	.reset (reset),
	.Clk (Clk),
	.AB (XAB),
	.write (XWRITE),
	.oe(XREAD),
	.DB (XDB) 
	);

async_ramb YRAM(
	.reset (reset),
	.Clk (Clk),
	.AB (YAB),
	.write (YWRITE),
	.oe(YREAD),
	.DB (YDB) 
	);

async_ramb PRAM(
	.reset (reset),
	.Clk (Clk),
	.AB (PAB),
	.write (1'b0),
	.oe (1'b1), 
	.DB (PDB)
	);


/*==============================================================================*/



endmodule	/* end module core+ */
