/*	File:	cr_test.v	  					*/

/*	module name: top						*/

/*	Description: TEST FILE						*/

/*	Tested Module name:	core_ram.v				*/


/*=======================================================================*/

/*************************************************************************/
/*									*/
/*	module:	top							*/
/*									*/
/*************************************************************************/

module top;



/*============		internal nets	=================================*/

reg reset;

reg Clk;

integer dumpfile, dumpfile_and_stdout;


/*=========================================================================*/



/*===========	Module Instantiations	 ===================================*/

core_ram_struc coreR(
	.reset (reset),
	.Clk (Clk)
	);

/*========================================================================*/


/*======================================================================*/
/*	initialize							*/
/*======================================================================*/

initial
	begin
	
		/* generates a dump file for Cwaves to use */
		$shm_open("wavesCR.shm");		
		/* keep track of all signals in the hierarcy */
		$shm_probe("AS");
		
		/* load data into RAM modules 		*/
		/* start at RAMData[00]             */
		$readmemh( "pmem_file", coreR.PRAM.RAMData, 8'h00);
		$readmemh( "xmem_file", coreR.XRAM.RAMData, 12'h00);
		$readmemh( "ymem_file", coreR.YRAM.RAMData, 12'h00);
		

		/* Start simulation with reset signal high */
		Clk = 0;
		reset = 1;	
	
		/* end of reset cycle */
		#100 reset = 0;
		

		#4000 $finish;		/* end simulation */
		
		$fclose(dumpfile);		

		$shm_close;		 /* close the dump file */
	end



/*======================================================================*/
/*	clock	50 units High, 50 units Low				*/
/* 		on each cycle, dump register contents			*/
/*======================================================================*/

   always
      begin
	 #50 Clk = 1;
	 #50 Clk = 0;
      end
   
endmodule	/* end module top */
