;
; This program originally available on the Motorola DSP bulletin board.
; It is provided under a DISCLAIMER OF WARRANTY available from
; Motorola DSP Operation, 6501 Wm. Cannon Drive W., Austin, Tx., 78735.
; 
; Last Update 16 Jul 87   Version 1.0
;
;
;       FIR test program
;
        opt     cex,mex
        page    132,66,0,10
        include 'fir'

npts    equ     $100              ;number of points to process
ntaps   equ     4               ;number of taps in filter

        org     x:0
states  dsm     ntaps           ;filter states

        org     y:0
coef    dc      .1,.3,-.1,.2    ;coefficients


;
;include data file which is an input filter
;
;
	include 'inputd.asm'

;
;Memory to store the results
;
;
        org     y:$100
datout  dsm     npts


;
;Start running the program
;
;
	     org	    p:0		;goto the beginning!
        jmp	    start



        org     p:$50
start
        move    #states,r0      ;point to filter states
        move    #ntaps-1,m0     ;mod(ntaps)
        move    #coef,r4        ;point to filter coefficients
        move    #ntaps-1,m4     ;mod(ntaps)

        move    #datin,r1       ; get the beginning of the input buffer
        move    #datout,r5      ; get the output buffer address

        move    x:(r1)+,x0      		;get 1st input sample

        do      #npts,endp
        fir     ntaps           		;do fir
        move    a,y:(r5)+	x:(r1)+,x0    ;save output sample 
        			    		;and get new input sample
endp

        jmp   endp
        nop
        nop
        nop
        

        end
