        include 'fir'

npts    equ     $100              ;number of points to process
ntaps   equ     64               ;number of taps in filter

        org     x:0
states  dsm     ntaps           ;filter states

        org     y:0
	include 'fir_coef'
	

;
;include data file which is an input filter
;
;
	include 'inputd.asm'

;
;Memory to store the results
;
;
        org     y:$100
datout  dsm     npts


;
;  Include the D vector
;
;
	include 'dvec.asm'

;
;Start running the program
;
;
	     org	    p:0		;goto the beginning!
        jmp	    start




        org     p:$50
start

;
;
; initialize the system for the LMS filter
;
;
; R registers used: r0(filter states), r4(coef), r5(coef update), 
;                   r6 (output data), r1 (input data), r2 (d vector)
;
;
;
        move    #states,r0      ;point to filter states
        move    #ntaps-1,m0     ;mod(ntaps)
        move	  #-2,n0	    ;adjustment for filtering (???)

        move    #coef,r4        ;point to filter coefficients
        move    #ntaps-1,m4     ;mod(ntaps)

	 move	  r4,r5	    ;coefficients
	 move    m0,m5

        move    #datin,r1       ; get the beginning of the input buffer
        move    #datout,r6      ; get the output buffer address


	 move	  #$200,r2        ; pointer to d vector

;
; get the sample
;
;

        move    x:(r1)+,x0      		;get 1st input sample
        

;
;
; do the FIR filter
;
;
        do      #npts,endp
        fir     ntaps           		;do fir


;
;
; save the sample
;
;
;        move    a,y:(r6)+	x:(r1)+,x0    ;save output sample 
        			    		;and get new input sample

	  move    a,y:(r6)+                ; save the sample only

;
;
; get d(n) and put it into x0 -> d(n) is the output I want at time n
; subtracted from x(n) and multiplied by "u"
;
;
	
	move	y:(r2)+,x0
       sub	x,b
       move	b0,x1
	

;
;
; update the coefficients
;
;
	move	x:(r0)+,x0 y:(r4)+,a			; get x(0), h0
	do	#ntaps,update				; update the coeffs
	macr	x0,x1,a x:(r0)+,x0 y:(r4)+,y0	; (e e(n) * x(n) ) + h
	tfr	y0,a a,y:(r5)+			; copy h, save new h
update
	move	x:(r0)+n0,x0 y:(r4)-,y0		; update r0,r4
	


;
;
; Get a new input sample
;
;
       move	x:(r1)+,x0

;
; end the program
;
;

endp

        jmp   endp
        nop
        nop
        nop
        

        end
