;
;
;       Instruction test program
;	Try every arithmatic instruction in ALU
;
;

;	org	p:0			;
;	jmp	start			; 

;
;Start running the program
;
;

;	org p:$50			; 
	org p:0		;
start
	nop			;

	;; check immediate data move
	move #$55,x0		;
	move #$b7,y0		; 

	;;  load some data into x and y registers
        move    #$ffffff,x1	;load x1 with all 1
	move	#$000001,x0		;load x0 with all 1
        move    #$555555,y0	;load y0 with 0101 pattern
	move	#$cccccc,y1	;load y1 with 1010 pattern

	;;  tranfer function
	tfr x1,a		; load a with all 1
	tfr y0,b		;  load b with 1010 pattern

	;; logic instruction

	and	y0,a		;
	or	y1,b		;
	eor	y0,b		;
	not	b		;

	;; shift instruction

	lsr a			;
	lsr b			;
	lsl a			;
	lsl b			;
	ror a			;
	ror b			;
	rol a			;
	rol b			;
	asr a			;
	asr b			;
	asl a			;
	asl b			;

	;; arithmatic instructions

	add y0,a		;
	sub y1,b		;
	add b,a			;
	sub b,a			;
	addl a,b		;
	addr a,b		;
	subl a,b		;
	subr a,b		;
	mpy x0,y1,a		;
	mpy x0,y0,b		; 
	rnd a			;
	mpy y0,y1,a		;
	mpy -y0,y1,b		;
	mpyr x0,y1,a		;
	mpyr -x0,y1,b		;
	mac x1,y0,a		;
	mac -x1,y0,b		; 
	macr x1,y1,a		;
	macr -x1,y1,b		;

	;; clear

	clr a			;
	clr b			;

	;; clear pipe
	nop
	nop
	nop
	
end
