/* $Id: decoder1_3.v,v 2.1 1998/02/10 04:39:16 inacio Exp $ */
/*****************************************************************************
 *
 * decoder1_3
 *
 * almost normal, the outputs are high when they are not passing the input 
 * signal, in_sig, through to one of the output signals.  Otherwise, a normal
 * decoder.
 *
 *
 *Copyright (C) 1997 Carnegie Mellon University
 *
 *Author: $Author: inacio $
 *Date: $Date: 1998/02/10 04:39:16 $
 *Revision: $Revision: 2.1 $
 *
 *
 *Log: $Log: decoder1_3.v,v $
 *Log: Revision 2.1  1998/02/10 04:39:16  inacio
 *Log: this is a 3-to-1 decoder with a little bizarre logic of being high when
 *Log: inactive for the control signals from the external port
 *Log:
 *****************************************************************************/
module decoder1_3 (in_sig, outx, outy, outp, select);

   input    in_sig;
   output   outx;
   output   outy; 
   output   outp;
   input    [1:0]select;
   

   wire     not_select0;
   wire     xcontrol;
   wire     ycontrol;
   wire     pcontrol;
   
   /*
    * stdor2 (in0, in1, y);
    * stdnand2 (in0, in1, y);
    * stdinv (in, y);
    */

   stdinv select_inv (select[0], not_select0);

   stdor2 x_sel (select[0], select[1], xcontrol);
   stdor2 y_sel (not_select0, select[1], ycontrol);
   stdnand2 p_sel (select[0], select[1], pcontrol);
   
   stdor2 x_or (in_sig, xcontrol, outx);
   stdor2 y_or (in_sig, ycontrol, outy);
   stdor2 p_or (in_sig, pcontrol, outp);
   


endmodule


/*****************************************************************************
 *****************************************************************************/
