/*	File:	mult_c.v	 			*/

/*	module name: mult_c				*/

/*	Description: multily/accumute module for ALU 	*/
/*			uses cascade mudule		*/
/*  For some reason, I need to left shift the result of */
/*  the cascade module by one bit to get the correct answer */
/*  It proabably has to do with the implied decimal point */

/*				Calculates x * y + a		*/


/*========================================================================*/


/***************************************************************************/
/*																			*/
/*	module:																	*/
/*																			*/
/***************************************************************************/

module mult_c (
	a, b,
	prod
	);


/*============	I/O direction	===========================================*/

input [`databus] a;
input [`databus] b;
output [47:0]	 prod;

/*=========================================================================*/


/*==================== I/O type ===========================================*/

wire [47:0]	 prod;

/*===================== internal =======================*/

wire [47:0]	casc_prod;

/*==========================================================================*/


/*==========================================================================*/
/*	processes							*/
/*==========================================================================*/


/* this is a cascade module */

hsmult2 #(24, 24, 48, "1") MULT (
	.A(a), .B(b),
	.PROD(casc_prod)
	);

assign prod =  {casc_prod[47:0]};

endmodule	/* end module */



