/* $Id: smisc_signals.v,v 1.3 1997/12/03 21:08:47 inacio Exp $ */
/*****************************************************************************
 *smisc_signals.v
 *
 *synthesizable verilog of some more misc. signals to deal with
 *
 *
 *Copyright (C) 1997 Carnegie Mellon University
 *
 *Author: $Author: inacio $
 *Date: $Date: 1997/12/03 21:08:47 $
 *Revision: $Revision: 1.3 $
 *
 *
 *Log: $Log: smisc_signals.v,v $
 *Log: Revision 1.3  1997/12/03 21:08:47  inacio
 *Log: updated the EACCESS signal to match the more current port definition
 *Log:
# Revision 1.2  1997/11/09  08:51:47  inacio
# I changed the tabbing in the files to be spaces, now it looks the same in
# less as it does in my editor
#
# Revision 1.1  1997/10/16  17:09:12  inacio
# This just deals with some misc signals that don't fit into other places
#
 *****************************************************************************/

module smisc_signals (cpu_stop, c_xab_ov, EACCESS);

input  cpu_stop;
input  c_xab_ov;
output EACCESS;

reg  EACCESS;
reg  ESTROBE;


always @(cpu_stop)
   begin
      /*
       * cpu_stop is active low
       */
      if (cpu_stop == 1'b0)
         begin
            EACCESS <= 1'b1;
         end
      else
         begin
            EACCESS <= 1'b0;
         end
   end
endmodule
